<?php

/* NoPro sql-lib
 * some handy funcs using mysql_*() functions
 */

function sqlstore($tbl, $arr, $idkey = null, $verbose = null, $keys = null) {
  /* the presence of $idkey, signals UPDATE instead of INSERT
   * $verbose means to print the query
   * $keys for non-associative $arr, or to override $k from $arr
   */
  $query = $idkey ? "INSERT INTO $tbl SET" : "UPDATE $tbl SET";
  foreach($arr as $k => $val) {
    $key = $keys ? $keys[$k] : $k;
    if(is_numeric($val))
      $query .= " $key = $val,";
    else if($val === null)
      $query .= " $key = NULL,";
    else
      $query .= " $key = '$val',";
  }
  $query = rtrim($query, ',');
  
  if($idkey)
    $query .= sprintf(" WHERE $idkey = %d", $arr[$idkey]);
  
  if($verbose)
    echo $query ."\n";
  
  mysql_query($query) or die("sqlstore(): ". mysql_error());
  if($idkey)
    $idval = $arr[$idkey];
  else
    $idval = mysql_insert_id();
  return $idval;
}

function sql2arr($query) {
  # fill array with sql-results
  $arr = array();
  $res = mysql_query($query) OR die("query(): ".mysql_error());
  while($row = mysql_fetch_assoc($res)) {
    array_push($arr, $row);
  }
  mysql_free_result($res);
  return $arr;
}

?>